﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.742.5/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var CompoundUserControl;
        (function (CompoundUserControl) {
            function ManageVariableByJavaScript(ControlName, GateName) {  //'Gate_LowerOne' 'Gate 2'  Use identifier not the control name
                
                if (TcHmi.Server.isWebsocketReady()) {                    
                    var myControl = TcHmi.Controls.get(ControlName.concat('.TcHmi_Controls_Beckhoff_TcHmiTextblock_GateControlName')); //Note actual field
                    if (myControl) {                     
                        myControl.setText(GateName);                        
                        var leftMotor = TcHmi.Controls.get(ControlName.concat('.Motor_LeftMotor'));
                        var rightMotor = TcHmi.Controls.get(ControlName.concat('.Motor_RightMotor'));
                        var sensorOne = TcHmi.Controls.get(ControlName.concat('.Motor_LeftMotor').concat('.Rotation__LeftSide').concat('.TcHmi_Controls_Beckhoff_TcHmiTextblock_MotorSpeed'));
                        var sensorTwo = TcHmi.Controls.get(ControlName.concat('.Motor_LeftMotor').concat('.Rotation__RightSide').concat('.TcHmi_Controls_Beckhoff_TcHmiTextblock_MotorSpeed'));
                        var sensorThree = TcHmi.Controls.get(ControlName.concat('.Motor_RightMotor').concat('.Rotation__LeftSide').concat('.TcHmi_Controls_Beckhoff_TcHmiTextblock_MotorSpeed'));
                        var sensorFour = TcHmi.Controls.get(ControlName.concat('.Motor_RightMotor').concat('.Rotation__RightSide').concat('.TcHmi_Controls_Beckhoff_TcHmiTextblock_MotorSpeed'));
                        var commands = [
                            {
                                'symbol': 'PLC1.MAIN.ArrayGate.1.ArrayMotorControl.0.startMotor'                                
                            },
                            {
                                'symbol': 'PLC1.MAIN.ArrayGate.1.ArrayMotorControl.1.startMotor'
                            },
                            {
                                'symbol': 'PLC1.MAIN.ArrayGate.1.ArrayMotorControl.0.ArrayROTATIONSENSOR.0.readData'
                            },
                            {
                                'symbol': 'PLC1.MAIN.ArrayGate.1.ArrayMotorControl.0.ArrayROTATIONSENSOR.1.readData'
                            },
                            {
                                'symbol': 'PLC1.MAIN.ArrayGate.1.ArrayMotorControl.1.ArrayROTATIONSENSOR.0.readData'
                            },
                            {
                                'symbol': 'PLC1.MAIN.ArrayGate.1.ArrayMotorControl.1.ArrayROTATIONSENSOR.1.readData'
                            }
                        ];

                        TcHmi.Server.subscribe(commands, 500, function (data) {
                            if (data.error !== TcHmi.Errors.NONE) {
                                // Handle TcHmi.Server class level error here.
                                return;
                            }
                            var response = data.response;
                            if (!response || response.error !== undefined) {
                                // Handle TwinCAT HMI Server response level error here.
                                return;
                            }
                            var commands = response.commands;
                            if (commands === undefined) {
                                return;
                            }
                            for (var i = 0, ii = commands.length; i < ii; i++) {
                                var command = commands[i];
                                if (command === undefined) {
                                    return;
                                }
                                if (command.error !== undefined) {
                                    // Handle TwinCAT HMI Server command level error here.
                                    return;
                                }
                                if (commands[i].symbol.localeCompare('PLC1.MAIN.ArrayGate.1.ArrayMotorControl.0.ArrayROTATIONSENSOR.0.readData') == 0) {
                                    if (sensorOne) {
                                        var num = command.readValue;
                                        sensorOne.setText(num.toFixed(2));
                                    }                                    
                                }
                                if (commands[i].symbol.localeCompare('PLC1.MAIN.ArrayGate.1.ArrayMotorControl.0.ArrayROTATIONSENSOR.1.readData') == 0) {
                                    if (sensorTwo) {
                                        var num = command.readValue;
                                        sensorTwo.setText(num.toFixed(2));
                                    }
                                }
                                if (commands[i].symbol.localeCompare('PLC1.MAIN.ArrayGate.1.ArrayMotorControl.1.ArrayROTATIONSENSOR.0.readData') == 0) {
                                    if (sensorThree) {
                                        var num = command.readValue;
                                        sensorThree.setText(num.toFixed(2));
                                    }
                                }
                                if (commands[i].symbol.localeCompare('PLC1.MAIN.ArrayGate.1.ArrayMotorControl.1.ArrayROTATIONSENSOR.1.readData') == 0) {
                                    if (sensorFour) {
                                        var num = command.readValue;
                                        sensorFour.setText(num.toFixed(2));
                                    }
                                }

                            } //for
                        }); // subscribe
                } //   if (myControl) 
                }//Web socket ready
            } //function ManageVariableByJavaScript(ControlName) {
            CompoundUserControl.ManageVariableByJavaScript = ManageVariableByJavaScript;
        })(CompoundUserControl = Functions.CompoundUserControl || (Functions.CompoundUserControl = {}));
        Functions.registerFunctionEx('ManageVariableByJavaScript', 'TcHmi.Functions.CompoundUserControl', CompoundUserControl.ManageVariableByJavaScript);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);